open Core;
open Process;
open System;
open Reset;
open Ioport;
object sys : system;
sys.clock  (100000 kilohz);
sys.reset_level (0);
sys.reset_internal(1);

open Random;
object rnd: random;

signal SW: logic[4];
reg LED: logic[8];

export LED,SW;

process main:
begin
  array pattern,collect: reg[4] of logic[4];
  reg pat: logic[4];
  reg sample: logic[4];
  reg correct: bool;
  reg d: logic[8];
  reg speed: int [4];
  rnd.init();

  -- pattern.[0] <- 0,
  -- pattern.[1] <- 2,
  -- pattern.[2] <- 1,
  -- pattern.[3] <- 3;
  speed <- 7;

  always do
  begin
    -- Generate random sequence
    for i = 0 to 3 do
    begin
	  rnd.read(d);
	  if d < 64 then pattern.[i] <- 0
	  else if d < 128 then pattern.[i] <- 1
	  else if d < 192  then pattern.[i] <- 2
	  else pattern.[i] <- 3;
    end;

    -- Show the pattern sequence
    -- LED <-0b00000001;
    for i = 0 to 3 do
    begin
	  LED <- 0;
	  for j = 0 to speed do begin wait for 50 millisec; end;
      pat <- pattern.[i];
	  pat <- pat lsl 1;
      LED <- 0b11 lsl pat;
      for j = 0 to speed do begin wait for 50 millisec; end;
    end;
    -- LED <-0b00000010;
	LED <- 0;
    -- Collect the user sequence
    for i = 0 to 3 do
    begin
      wait for SW <> 0b1111;
      sample <- SW;
      -- LED <- 0b00000100;
      match sample with
      begin
        when 0b1110:
        begin
          collect.[i]<-0;
		  LED <- 0b11;
        end;
        when 0b1101:
        begin
          collect.[i]<-1;
		  LED <- 0b1100;
        end;
        when 0b1011:
        begin
          collect.[i]<-2;
		  LED <- 0b110000;
        end;
        when 0b0111:
        begin
          collect.[i]<-3;
		  LED <- 0b11000000;
        end;
		when others:
		begin
		  i <- i+1;
		  LED <- 0b10101010;
		end;
      end;
      wait for 100 millisec;
      wait for SW = 0b1111;
	  -- LED <- 0b00001000;
	  LED <- 0;
	  wait for 100 millisec;
    end;
    correct <- true;
    for i = 0 to 3 do
    begin
      if (collect.[i] <> pattern.[i]) then correct <- false;
    end;
	-- LED <- 0b00010000;
    if (correct = true) then
      begin
	    for i = 1 to 3 do
	    begin
	      LED <- 0b11111111;
		  wait for 500 millisec;
          LED <- 0b00000000;
		  wait for 500 millisec;
	    end;
	end;
	speed <- speed - 1;
	if speed=0 then speed <- 7;
  end;
end;
