--
-- Automatically generated by
-- CONPRO: Hardware Synthesis with an Imperative High Level Multiprocess Approach
--         (C) 2006-2017 by Dr. Stefan Bosse
--         Version: 2.1 Revision: D197 Genetic size: 2735692
--         Compile date: Thu Mar 16 14:39:32 CET 2017
--         Compiled by:  sbosse
--         Compiled on:  SunOS suna64z 5.11 snv_134 i86pc i386 i86pc Solaris

-- Implementation of Module <Memo>.
--
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
-- use IEEE.numeric_std.all;
use IEEE.std_logic_unsigned.all;
use work.ConPRO.all;
entity MOD_memo is
port(
  -- Connections to the outside world
  signal SW: in std_logic_vector(3 downto 0);
  signal LED_RD: out std_logic_vector(7 downto 0);
  signal CLK: in std_logic
);
end MOD_memo;
architecture main of MOD_memo is
  -- Process instances
  component memo_main
  port(
    -- Connections to external objects, components and the outside world
    signal REG_LED_WR: out std_logic_vector(7 downto 0);
    signal REG_LED_WE: out std_logic;
    signal RND_rnd_RE: out std_logic;
    signal RND_rnd_RD: in std_logic_vector(7 downto 0);
    signal RND_rnd_INIT: out std_logic;
    signal RND_rnd_GD: in std_logic;
    signal SW_RD: in std_logic_vector(3 downto 0);
    signal PRO_main_ENABLE: in std_logic;
    signal PRO_main_END: out std_logic;
    signal conpro_system_clk: in std_logic;
    signal conpro_system_reset: in std_logic
  );
  end component;
  -- Local and temporary data objects
  signal REG_LED: std_logic_vector(7 downto 0);
  signal REG_LED_main_WR: std_logic_vector(7 downto 0);
  signal REG_LED_main_WE: std_logic;
  signal RND_rnd_main_RD: std_logic_vector(7 downto 0);
  signal RND_rnd_d_in: std_logic;
  signal RND_rnd_seed: std_logic_vector(7 downto 0);
  signal RND_rnd_data_shift: std_logic_vector(7 downto 0);
  signal RND_rnd_data: std_logic_vector(7 downto 0);
  signal RND_rnd_shift: std_logic;
  signal RND_rnd_init: std_logic;
  signal RND_rnd_avail: std_logic;
  signal RND_rnd_main_RE: std_logic;
  signal RND_rnd_main_INIT: std_logic;
  signal RND_rnd_main_GD: std_logic;
  signal RND_rnd_count: std_logic_vector(2 downto 0);
  signal PRO_main_ENABLE: std_logic;
  signal PRO_main_END: std_logic;
  signal SW_RD: std_logic_vector(3 downto 0);
  -- State Processing
  -- Aux. signals
  signal conpro_system_clk: std_logic;
  signal conpro_system_reset: std_logic;
  signal RESET: std_logic;
  type RESET_STATES is (RESET_S0,RESET_S1,RESET_S2,RESET_S3);
  signal RESET_STATE: RESET_STATES := RESET_S0;
begin
  -- Module implementation
  -- Register
  IMPL_REG_LED: process(
          REG_LED_main_WR,
          REG_LED_main_WE,
          REG_LED,
          conpro_system_clk,
          conpro_system_reset
          )
  begin
    if conpro_system_clk'event and conpro_system_clk='1' then
     if conpro_system_reset='0' then
      REG_LED <= "00000000";
     elsif REG_LED_main_WE='1' then
      REG_LED <= REG_LED_main_WR;
     end if;
    end if;
  end process IMPL_REG_LED;
  
  --
  --  ConPro V2.1.D197 EMI Random.random V2.10
  --
  
  --
  -- EMI <Object Random.random.rnd> Process
  --
  RANDOM_rnd_SCHED: process(conpro_system_clk,
    conpro_system_reset,
    RND_rnd_init,
    RND_rnd_main_INIT,
    RND_rnd_main_RE,
    RND_rnd_avail,
    RND_rnd_data)
  begin
    if (conpro_system_clk'event) and ((conpro_system_clk) = ('1')) then
      if (conpro_system_reset) = ('0') then
        RND_rnd_shift <= '0';
        RND_rnd_init <= '0';
        RND_rnd_main_GD <= '1';
      else
        RND_rnd_main_GD <= '1';
        if (RND_rnd_init) = ('1') then
          RND_rnd_init <= '0';
        elsif (RND_rnd_main_INIT) = ('1') then
          RND_rnd_init <= '1';
          RND_rnd_seed <= "11111111";
          RND_rnd_main_GD <= '0';
        elsif (RND_rnd_main_RE) = ('1') then
          RND_rnd_shift <= '1';
          if (RND_rnd_avail) = ('1') then
            RND_rnd_main_RD <= RND_rnd_data;
            RND_rnd_main_GD <= '0';
            RND_rnd_shift <= '0';
          end if;
        end if;
      end if;
    end if;
  end process RANDOM_rnd_SCHED;
  --
  -- EMI <Object Random.random.rnd> Process
  --
  RANDOM_rnd: process(conpro_system_clk,
    conpro_system_reset,
    RND_rnd_init,
    RND_rnd_seed,
    RND_rnd_shift,
    RND_rnd_d_in,
    RND_rnd_data_shift,
    RND_rnd_count)
  begin
    if (conpro_system_clk'event) and ((conpro_system_clk) = ('1')) then
      if ((conpro_system_reset) = ('0')) or ((RND_rnd_init) = ('1')) then
        RND_rnd_data_shift <= RND_rnd_seed;
        RND_rnd_data <= "00000000";
        RND_rnd_count <= "000";
        RND_rnd_avail <= '0';
      elsif (RND_rnd_shift) = ('1') then
        RND_rnd_data_shift <= (RND_rnd_d_in) & (RND_rnd_data_shift(7 downto 1));
        RND_rnd_count <= (RND_rnd_count) + (1);
        if (RND_rnd_count) = ("111") then
          RND_rnd_avail <= '1';
          RND_rnd_data <= RND_rnd_data_shift;
          RND_rnd_count <= "000";
        else
          RND_rnd_avail <= '0';
        end if;
      end if;
    end if;
  end process RANDOM_rnd;
  --
  -- EMI <Object Random.random.rnd>
  --
  RND_rnd_d_in <= (RND_rnd_data_shift(0)) xor ((RND_rnd_data_shift(4)) xor ((RND_rnd_data_shift(5)) xor (RND_rnd_data_shift(7))));
  --
  -- End of <Object Random.random.rnd>
  --
  
  -- Process control
  PRO_CONTROL_main: process(
          conpro_system_clk,
          conpro_system_reset
          )
  begin
    if conpro_system_clk'event and conpro_system_clk = '1' then
      if conpro_system_reset = '0' then
        PRO_main_ENABLE <= '1'; -- main process activated on reset
      end if;
    end if;
  end process PRO_CONTROL_main;
  
  
  -- Process instantiations
  PRO_MAP_main: memo_main port map(
    REG_LED_WR => REG_LED_main_WR,
    REG_LED_WE => REG_LED_main_WE,
    RND_rnd_RE => RND_rnd_main_RE,
    RND_rnd_RD => RND_rnd_main_RD,
    RND_rnd_INIT => RND_rnd_main_INIT,
    RND_rnd_GD => RND_rnd_main_GD,
    SW_RD => SW_RD,
    PRO_main_ENABLE => PRO_main_ENABLE,
    PRO_main_END => PRO_main_END,
    conpro_system_clk => conpro_system_clk,
    conpro_system_reset => conpro_system_reset
  );
  
  -- Toplevel assignments
  -- Monitors
  SW_RD <= SW;
  LED_RD <= REG_LED;
  conpro_system_clk <= CLK;
  conpro_system_reset <= RESET;
  RESET_CTRL:process(conpro_system_clk,RESET_STATE)
  begin
    if conpro_system_clk'event and conpro_system_clk = '1' then
      case RESET_STATE is
        when RESET_S0 => RESET <= '1'; RESET_STATE <= RESET_S1;
        when RESET_S1 => RESET <= '0'; RESET_STATE <= RESET_S2;
        when RESET_S2 => RESET <= '0'; RESET_STATE <= RESET_S3;
        when RESET_S3 => RESET <= '1'; RESET_STATE <= RESET_S3;
      end case;
    end if;
  end process;
end main;
